import { ComponentInternalInstance, ObjectDirective } from 'vue';
import { EventsBackboneEventHandler, EventsBackboneSpineEntryOption, EventsBackboneDirectiveParams, EventsBackboneSpineInterface } from '../types';
export declare class EventsBackboneSpine implements EventsBackboneSpineInterface {
    private readonly evntsTree;
    private readonly lstnrsRegistry;
    private readonly compsRegistry;
    private readonly listenAllSymbol;
    constructor();
    private _getComponentFromUid;
    private _callHandler;
    private _internalEmitGlobalEvent;
    private _internalEmitEvent;
    private _getBranchSymbols;
    emitEvent<T>(cInst: ComponentInternalInstance, ev: string, d?: T, configs?: {
        global?: boolean;
        eager?: boolean;
    }): Promise<void>;
    private _addEventEntry;
    private _checkEventEntryValidity;
    private _removeEventEntry;
    private _rebuildEventNameFromSymbol;
    private _rebuildEventNameFromEventEntry;
    private _findEventEntryFromNodeName;
    private _getEventEntry;
    private _findEventEntry;
    private _checkEventNameValidity;
    private _addListener;
    private _addListenerEntry;
    private _addCompEntrySymbol;
    private _removeCompEntry;
    private _removeCompEntrySymbol;
    private _removeListenerEntry;
    private _removeListener;
    on(c: ComponentInternalInstance, ev: string, h: EventsBackboneEventHandler, opts?: EventsBackboneSpineEntryOption): void;
    off(uid: number, ev: string, h?: EventsBackboneEventHandler): void;
    offAll(uid: number): void;
}
export declare const BB: EventsBackboneSpine;
export declare const EventsBackBoneDirective: ObjectDirective<any, EventsBackboneDirectiveParams>;
